## bedops 2.4.42+dfsg

=== Makefile ===
export KERNEL         := ${shell uname -a | cut -f1 -d' '}
APPDIR                 = applications/bed
OTHERDIR               = applications/other
OSXPKGROOT             = packaging/os_x
OSXBUILDDIR            = ${OSXPKGROOT}/build
OSXPKGDIR              = ${OSXPKGROOT}/resources/bin
OSXLIBDIR              = ${OSXPKGROOT}/resources/lib
SELF                   = ${shell pwd}/Makefile
MASSIVE_REST_EXP       = 22
MASSIVE_ID_EXP         = 18
MASSIVE_CHROM_EXP      = 8
MEASURE128BIT          = 'long double'
JPARALLEL              = 8
MEGAROW                = megarow
TYPICAL                = typical
FLOAT128               = float128
ALL_BINARY_TYPES       = ${TYPICAL} ${MEGAROW} ${FLOAT128}
DEFAULT_BINARY_TYPE    = ${TYPICAL}
export BINARY_TYPE     = ${DEFAULT_BINARY_TYPE}
DEBUG_TYPE             = ${TYPICAL}
WRAPPERS               = $(wildcard ${APPDIR}/conversion/src/wrappers/*)
CWD                   := $(shell pwd)
BINDIR                 = bin
BINDIR_MODULE          = modules
export DESTBINDIR      = .

default:
ifeq ($(KERNEL), Darwin)
	$(MAKE) $(MAKECMDGOALS) -j $(JPARALLEL) -f system.mk/Makefile.darwin
else
	$(MAKE) $(MAKECMDGOALS) -j $(JPARALLEL) -f system.mk/Makefile.linux
endif

clean: default

support: default

debug: default

gprof: default

all:
	$(MAKE) support -f ${SELF}
	$(MAKE) typical -f ${SELF}
	$(MAKE) megarow -f ${SELF}
	$(MAKE) float128 -f ${SELF}
	$(MAKE) install_all -f ${SELF}
	$(MAKE) symlink_post_install_all -f ${SELF}

module_all:
	$(MAKE) support -f ${SELF}
	$(MAKE) typical -f ${SELF}
	$(MAKE) megarow -f ${SELF}
	$(MAKE) float128 -f ${SELF}
	$(MAKE) install_all -f ${SELF}
	$(MAKE) module_binaries -f ${SELF}

float128:
	$(MAKE) BINARY_TYPE=$(FLOAT128) MEGAFLAGS="-DMEASURE_TYPE=${MEASURE128BIT}" -f ${SELF}

megarow:
	$(MAKE) BINARY_TYPE=$(MEGAROW) MEGAFLAGS="-DREST_EXPONENT=${MASSIVE_REST_EXP} -DID_EXPONENT=${MASSIVE_ID_EXP} -DCHROM_EXPONENT=${MASSIVE_CHROM_EXP}" -f ${SELF}

typical:
	$(MAKE) BINARY_TYPE=$(TYPICAL) -f ${SELF}

symlink_post_install_all:
	cd ${BINDIR} && ./switch-BEDOPS-binary-type --typical . && cd ${CWD}

symlink_typical:
ifeq ($(KERNEL), Darwin)
	$(eval SRCNAMES=`find $(BINDIR)/ -maxdepth 1 -mindepth 1 -type f -name '*$(TYPICAL)' -print0 | xargs -L1 -0 -I{} sh -c 'basename {}'`)
else
	$(eval SRCNAMES=`find $(BINDIR)/ -maxdepth 1 -mindepth 1 -type f -name '*$(TYPICAL)' -print0 | xargs -I{} -0 sh -c 'basename {}' | xargs -L1`)
endif
	for SRCNAME in ${SRCNAMES}; do \
		DESTNAME=`echo $$SRCNAME | sed 's/-$(TYPICAL)//'`; \
		ln -sf $$SRCNAME $(BINDIR)/$${DESTNAME}; \
	done

symlink_megarow:
ifeq ($(KERNEL), Darwin)
	$(eval SRCNAMES=`find $(BINDIR)/ -maxdepth 1 -mindepth 1 -type f -name '*$(MEGAROW)' -print0 | xargs -L1 -0 -I{} sh -c 'basename {}'`)
else
	$(eval SRCNAMES=`find $(BINDIR)/ -maxdepth 1 -mindepth 1 -type f -name '*$(MEGAROW)' -print0 | xargs -I{} -0 sh -c 'basename {}' | xargs -L1`)
endif
	for SRCNAME in ${SRCNAMES}; do \
		DESTNAME=`echo $$SRCNAME | sed 's/-$(MEGAROW)//'`; \
		ln -sf $$SRCNAME $(BINDIR)/$${DESTNAME}; \
	done

symlink_float128:
ifeq ($(KERNEL), Darwin)
	$(eval SRCNAMES=`find $(BINDIR)/ -maxdepth 1 -mindepth 1 -type f -name '*$(FLOAT128)' -print0 | xargs -L1 -0 -I{} sh -c 'basename {}'`)
else
	$(eval SRCNAMES=`find $(BINDIR)/ -maxdepth 1 -mindepth 1 -type f -name '*$(FLOAT128)' -print0 | xargs -I{} -0 sh -c 'basename {}' | xargs -L1`)
endif
	for SRCNAME in ${SRCNAMES}; do \
		DESTNAME=`echo $$SRCNAME | sed 's/-$(FLOAT128)//'`; \
		ln -sf $$SRCNAME $(BINDIR)/$${DESTNAME}; \
	done

install: prep_c install_conversion_scripts install_starch_scripts
	-cp ${APPDIR}/sort-bed/bin/sort-bed-${TYPICAL} ${BINDIR}/sort-bed
	-cp ${APPDIR}/sort-bed/bin/update-sort-bed-slurm-${TYPICAL} ${BINDIR}/update-sort-bed-slurm
	-cp ${APPDIR}/sort-bed/bin/update-sort-bed-starch-slurm-${TYPICAL} ${BINDIR}/update-sort-bed-starch-slurm
	-cp ${APPDIR}/sort-bed/bin/update-sort-bed-migrate-candidates-${TYPICAL} ${BINDIR}/update-sort-bed-migrate-candidates
	-cp ${APPDIR}/bedops/bin/bedops-${TYPICAL} ${BINDIR}/bedops
	-cp ${APPDIR}/closestfeats/bin/closest-features-${TYPICAL} ${BINDIR}/closest-features
	-cp ${APPDIR}/bedmap/bin/bedmap-${TYPICAL} ${BINDIR}/bedmap
	-cp ${APPDIR}/bedextract/bin/bedextract-${TYPICAL} ${BINDIR}/bedextract
	-cp ${APPDIR}/starch/bin/starch-${TYPICAL} ${BINDIR}/starch
	-cp ${APPDIR}/starch/bin/unstarch-${TYPICAL} ${BINDIR}/unstarch
	-cp ${APPDIR}/starch/bin/starchcat-${TYPICAL} ${BINDIR}/starchcat
	-cp ${APPDIR}/starch/bin/starchstrip-${TYPICAL} ${BINDIR}/starchstrip
	-cp ${APPDIR}/conversion/bin/convert2bed-${TYPICAL} ${BINDIR}/convert2bed

install_float128: prep_c install_conversion_scripts
	-cp ${APPDIR}/sort-bed/bin/sort-bed-${FLOAT128} ${BINDIR}/sort-bed
	-cp ${APPDIR}/sort-bed/bin/update-sort-bed-slurm-${FLOAT128} ${BINDIR}/update-sort-bed-slurm
	-cp ${APPDIR}/sort-bed/bin/update-sort-bed-starch-slurm-${FLOAT128} ${BINDIR}/update-sort-bed-starch-slurm
	-cp ${APPDIR}/sort-bed/bin/update-sort-bed-migrate-candidates-${FLOAT128} ${BINDIR}/update-sort-bed-migrate-candidates
	-cp ${APPDIR}/bedops/bin/bedops-${FLOAT128} ${BINDIR}/bedops
	-cp ${APPDIR}/closestfeats/bin/closest-features-${FLOAT128} ${BINDIR}/closest-features
	-cp ${APPDIR}/bedmap/bin/bedmap-${FLOAT128} ${BINDIR}/bedmap
	-cp ${APPDIR}/bedextract/bin/bedextract-${FLOAT128} ${BINDIR}/bedextract
	-cp ${APPDIR}/starch/bin/starch-${FLOAT128} ${BINDIR}/starch
	-cp ${APPDIR}/starch/bin/unstarch-${FLOAT128} ${BINDIR}/unstarch
	-cp ${APPDIR}/starch/bin/starchcat-${FLOAT128} ${BINDIR}/starchcat
	-cp ${APPDIR}/starch/bin/starchstrip-${FLOAT128} ${BINDIR}/starchstrip
	-cp ${APPDIR}/conversion/bin/convert2bed-${FLOAT128} ${BINDIR}/convert2bed

install_megarow: prep_c install_conversion_scripts
	-cp ${APPDIR}/sort-bed/bin/sort-bed-${MEGAROW} ${BINDIR}/sort-bed
	-cp ${APPDIR}/sort-bed/bin/update-sort-bed-slurm-${MEGAROW} ${BINDIR}/update-sort-bed-slurm
	-cp ${APPDIR}/sort-bed/bin/update-sort-bed-starch-slurm-${MEGAROW} ${BINDIR}/update-sort-bed-starch-slurm
	-cp ${APPDIR}/sort-bed/bin/update-sort-bed-migrate-candidates-${MEGAROW} ${BINDIR}/update-sort-bed-migrate-candidates
	-cp ${APPDIR}/bedops/bin/bedops-${MEGAROW} ${BINDIR}/bedops
	-cp ${APPDIR}/closestfeats/bin/closest-features-${MEGAROW} ${BINDIR}/closest-features
	-cp ${APPDIR}/bedmap/bin/bedmap-${MEGAROW} ${BINDIR}/bedmap
	-cp ${APPDIR}/bedextract/bin/bedextract-${MEGAROW} ${BINDIR}/bedextract
	-cp ${APPDIR}/starch/bin/starch-${MEGAROW} ${BINDIR}/starch
	-cp ${APPDIR}/starch/bin/unstarch-${MEGAROW} ${BINDIR}/unstarch
	-cp ${APPDIR}/starch/bin/starchcat-${MEGAROW} ${BINDIR}/starchcat
	-cp ${APPDIR}/starch/bin/starchstrip-${MEGAROW} ${BINDIR}/starchstrip
	-cp ${APPDIR}/conversion/bin/convert2bed-${MEGAROW} ${BINDIR}/convert2bed

install_all: prep_c install_conversion_scripts_all install_starch_scripts_all
	for btype in ${ALL_BINARY_TYPES}; do \
		cp ${APPDIR}/sort-bed/bin/sort-bed-$$btype ${BINDIR}/sort-bed-$$btype; \
		cp ${APPDIR}/sort-bed/bin/update-sort-bed-slurm-$$btype ${BINDIR}/update-sort-bed-slurm-$$btype; \
		cp ${APPDIR}/sort-bed/bin/update-sort-bed-starch-slurm-$$btype ${BINDIR}/update-sort-bed-starch-slurm-$$btype; \
		cp ${APPDIR}/sort-bed/bin/update-sort-bed-migrate-candidates-$$btype ${BINDIR}/update-sort-bed-migrate-candidates-$$btype; \
		cp ${APPDIR}/bedops/bin/bedops-$$btype ${BINDIR}/bedops-$$btype; \
		cp ${APPDIR}/closestfeats/bin/closest-features-$$btype ${BINDIR}/closest-features-$$btype; \
		cp ${APPDIR}/bedmap/bin/bedmap-$$btype ${BINDIR}/bedmap-$$btype; \
		cp ${APPDIR}/bedextract/bin/bedextract-$$btype ${BINDIR}/bedextract-$$btype; \
		cp ${APPDIR}/starch/bin/starch-$$btype ${BINDIR}/starch-$$btype; \
		cp ${APPDIR}/starch/bin/unstarch-$$btype ${BINDIR}/unstarch-$$btype; \
		cp ${APPDIR}/starch/bin/starchcat-$$btype ${BINDIR}/starchcat-$$btype; \
		cp ${APPDIR}/starch/bin/starchstrip-$$btype ${BINDIR}/starchstrip-$$btype; \
		cp ${APPDIR}/conversion/bin/convert2bed-$$btype ${BINDIR}/convert2bed-$$btype; \
	done
	-cp ${OTHERDIR}/switch-BEDOPS-binary-type ${BINDIR}

module_binaries:
	for btype in ${ALL_BINARY_TYPES}; do \
		mkdir -p ${BINDIR_MODULE}/$$btype; \
		cp ${BINDIR}/sort-bed-$$btype ${BINDIR_MODULE}/$$btype/sort-bed; \
		cp ${BINDIR}/update-sort-bed-slurm-$$btype ${BINDIR_MODULE}/$$btype/update-sort-bed-slurm; \
		cp ${BINDIR}/update-sort-bed-starch-slurm-$$btype ${BINDIR_MODULE}/$$btype/update-sort-bed-starch-slurm; \
		cp ${BINDIR}/update-sort-bed-migrate-candidates-$$btype ${BINDIR_MODULE}/$$btype/update-sort-bed-migrate-candidates; \
		cp ${BINDIR}/bedops-$$btype ${BINDIR_MODULE}/$$btype/bedops; \
		cp ${BINDIR}/closest-features-$$btype ${BINDIR_MODULE}/$$btype/closest-features; \
		cp ${BINDIR}/bedmap-$$btype ${BINDIR_MODULE}/$$btype/bedmap; \
		cp ${BINDIR}/bedextract-$$btype ${BINDIR_MODULE}/$$btype/bedextract; \
		cp ${BINDIR}/starch-$$btype ${BINDIR_MODULE}/$$btype/starch; \
		cp ${BINDIR}/unstarch-$$btype ${BINDIR_MODULE}/$$btype/unstarch; \
		cp ${BINDIR}/starchcat-$$btype ${BINDIR_MODULE}/$$btype/starchcat; \
		cp ${BINDIR}/starchstrip-$$btype ${BINDIR_MODULE}/$$btype/starchstrip; \
		cp ${BINDIR}/starch-diff-$$btype ${BINDIR_MODULE}/$$btype/starch-diff; \
		cp ${BINDIR}/convert2bed-$$btype ${BINDIR_MODULE}/$$btype/convert2bed; \
		cp ${BINDIR}/bam2bed-$$btype ${BINDIR_MODULE}/$$btype/bam2bed; \
		cp ${BINDIR}/gff2bed-$$btype ${BINDIR_MODULE}/$$btype/gff2bed; \
		cp ${BINDIR}/gtf2bed-$$btype ${BINDIR_MODULE}/$$btype/gtf2bed; \
		cp ${BINDIR}/gvf2bed-$$btype ${BINDIR_MODULE}/$$btype/gvf2bed; \
		cp ${BINDIR}/psl2bed-$$btype ${BINDIR_MODULE}/$$btype/psl2bed; \
		cp ${BINDIR}/rmsk2bed-$$btype ${BINDIR_MODULE}/$$btype/rmsk2bed; \
		cp ${BINDIR}/sam2bed-$$btype ${BINDIR_MODULE}/$$btype/sam2bed; \
		cp ${BINDIR}/vcf2bed-$$btype ${BINDIR_MODULE}/$$btype/vcf2bed; \
		cp ${BINDIR}/wig2bed-$$btype ${BINDIR_MODULE}/$$btype/wig2bed; \
		cp ${BINDIR}/bam2starch-$$btype ${BINDIR_MODULE}/$$btype/bam2starch; \
		cp ${BINDIR}/gff2starch-$$btype ${BINDIR_MODULE}/$$btype/gff2starch; \
		cp ${BINDIR}/gtf2starch-$$btype ${BINDIR_MODULE}/$$btype/gtf2starch; \
		cp ${BINDIR}/gvf2starch-$$btype ${BINDIR_MODULE}/$$btype/gvf2starch; \
		cp ${BINDIR}/psl2starch-$$btype ${BINDIR_MODULE}/$$btype/psl2starch; \
		cp ${BINDIR}/rmsk2starch-$$btype ${BINDIR_MODULE}/$$btype/rmsk2starch; \
		cp ${BINDIR}/sam2starch-$$btype ${BINDIR_MODULE}/$$btype/sam2starch; \
		cp ${BINDIR}/vcf2starch-$$btype ${BINDIR_MODULE}/$$btype/vcf2starch; \
		cp ${BINDIR}/wig2starch-$$btype ${BINDIR_MODULE}/$$btype/wig2starch; \
		cp ${BINDIR}/bam2bed_sge-$$btype ${BINDIR_MODULE}/$$btype/bam2bed_sge; \
		cp ${BINDIR}/bam2bed_slurm-$$btype ${BINDIR_MODULE}/$$btype/bam2bed_slurm; \
		cp ${BINDIR}/bam2bed_gnuParallel-$$btype ${BINDIR_MODULE}/$$btype/bam2bed_gnuParallel; \
		cp ${BINDIR}/bam2starch_sge-$$btype ${BINDIR_MODULE}/$$btype/bam2starch_sge; \
		cp ${BINDIR}/bam2starch_slurm-$$btype ${BINDIR_MODULE}/$$btype/bam2starch_slurm; \
		cp ${BINDIR}/bam2starch_gnuParallel-$$btype ${BINDIR_MODULE}/$$btype/bam2starch_gnuParallel; \
		cp ${BINDIR}/starchcluster_sge-$$btype ${BINDIR_MODULE}/$$btype/starchcluster_sge; \
		cp ${BINDIR}/starchcluster_gnuParallel-$$btype ${BINDIR_MODULE}/$$btype/starchcluster_gnuParallel; \
		cp ${BINDIR}/starchcluster_slurm-$$btype ${BINDIR_MODULE}/$$btype/starchcluster_slurm; \
		cp ${BINDIR}/starch-diff-$$btype ${BINDIR_MODULE}/$$btype/starch-diff; \
	done

#######################
# install details

prep_c:
	mkdir -p ${BINDIR}

install_debug: prep_c install_conversion_scripts install_starch_scripts
	find ${APPDIR}/ -maxdepth 4 -mindepth 1 -type f -name 'debug.*${DEBUG_TYPE}' -exec cp {} ${BINDIR} \;

install_gprof: prep_c install_conversion_scripts install_starch_scripts
	-cp ${APPDIR}/sort-bed/bin/gprof.sort-bed ${BINDIR}/gprof.sort-bed
	-cp ${APPDIR}/sort-bed/bin/update-sort-bed-slurm ${BINDIR}/update-sort-bed-slurm
	-cp ${APPDIR}/sort-bed/bin/update-sort-bed-starch-slurm ${BINDIR}/update-sort-bed-starch-slurm

=== docs/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

# User-friendly check for sphinx-build
ifeq ($(shell which $(SPHINXBUILD) >/dev/null 2>&1; echo $$?), 1)
$(error The '$(SPHINXBUILD)' command was not found. Make sure you have Sphinx installed, then set the SPHINXBUILD environment variable to point to the full path of the '$(SPHINXBUILD)' executable. Alternatively you can add the directory with the executable to your PATH. If you don't have Sphinx installed, grab it from http://sphinx-doc.org/)
endif

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  latexpdfja to make LaTeX files and run them through platex/dvipdfmx"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	find $(BUILDDIR)/../assets -type f -name "*.png" -exec cp -f "{}" $(BUILDDIR)/html/_static \;
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/BEDOPS.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/BEDOPS.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/BEDOPS"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/BEDOPS"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

latexpdfja:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through platex and dvipdfmx..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf-ja
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

xml:
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

pseudoxml:
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."

=== tests/Makefile ===
CWD := $(shell pwd)
SWITCH = $(CWD)/../bin/switch-BEDOPS-binary-type
ALL_BINARY_TYPES = typical megarow float128
SHELL := /bin/bash

all: tests

.PHONY: tests bedops starch conversion

tests:
	$(MAKE) bedops -C $(CWD)/tests
	$(MAKE) starch -C $(CWD)/tests
	$(MAKE) conversion -C $(CWD)/tests
	$(MAKE) clean -C $(CWD)/tests

bedops: 
	for btype in ${ALL_BINARY_TYPES}; do \
		(cd $(CWD)/../bin && $(SWITCH) --$$btype . && cd $(CWD)) || exit $$?; \
		$(MAKE) all -C $(CWD)/bedops BUILDTYPE=$$btype; \
	done

starch: 
	for btype in ${ALL_BINARY_TYPES}; do \
		(cd $(CWD)/../bin && $(SWITCH) --$$btype . && cd $(CWD)) || exit $$?; \
		$(MAKE) all -C $(CWD)/starch BUILDTYPE=$$btype; \
	done

conversion:
	for btype in ${ALL_BINARY_TYPES}; do \
		(cd $(CWD)/../bin && $(SWITCH) --$$btype . && cd $(CWD)) || exit $$?; \
		$(MAKE) all -C $(CWD)/conversion BUILDTYPE=$$btype; \
	done

clean:
	(cd $(CWD)/../bin && $(SWITCH) --typical . && cd $(CWD)) || exit $$?

=== tests/bedops/Makefile ===
APP = bedops
CWD := $(abspath $(patsubst %/,%,$(dir $(abspath $(lastword $(MAKEFILE_LIST))))))
BIN = $(CWD)/../../bin/bedops
TMP := $(shell mktemp -d)
DATA = $(CWD)/data
SHELL := /bin/bash

all: 
	@echo "Testing binary [$(APP)] and build type [$(BUILDTYPE)]"
	@$(MAKE) tests

tests: bedops_prep merge complement intersection difference symdiff element-of not-element-of union partition chrom chop stdin named-pipe ec
	@echo "Removing [$(TMP)]"
	@rm -rf $(TMP)

bedops_prep:
	@[ -f $(BIN) ] || echo "Missing binary [$(APP)] for build type [$(BUILDTYPE)]"
	@echo "Writing to [$(TMP)]"
	$(BIN) --version

merge:
#	Test 001
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 001]"
	@$(BIN) -m $(DATA)/001.merge.001.test > $(TMP)/001.merge.001.observed
	@diff $(TMP)/001.merge.001.observed $(DATA)/001.merge.001.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
#	Test 002
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 002]"
	@$(BIN) -m $(DATA)/001.merge.001.test $(DATA)/001.complement.001.expected > $(TMP)/002.merge.002.observed
	@diff $(TMP)/002.merge.002.observed $(DATA)/002.merge.002.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
#	Test 003
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 003]"
	@$(BIN) -m $(DATA)/003.merge.003.test > $(TMP)/003.merge.003.observed
	@diff $(TMP)/003.merge.003.observed $(DATA)/003.merge.003.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
#	Test 004
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 004]"
	@$(BIN) -m $(DATA)/001.merge.001.test $(DATA)/003.merge.003.test > $(TMP)/004.merge.004.observed
	@diff $(TMP)/004.merge.004.observed $(DATA)/004.merge.004.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
#	Test 005
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 005]"
	@$(BIN) -m $(DATA)/005.merge.005.test $(DATA)/004.merge.004.expected > $(TMP)/005.merge.005.observed
	@diff $(TMP)/005.merge.005.observed $(DATA)/005.merge.005.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
#	Test 006
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 006]"
	@$(BIN) -m $(DATA)/006.merge.006a.test $(DATA)/006.merge.006b.test $(DATA)/006.merge.006c.test > $(TMP)/006.merge.006.observed
	@diff $(TMP)/006.merge.006.observed $(DATA)/006.merge.006.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
#	Test 007
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 007]"
	@$(BIN) -m $(DATA)/007.merge.007a.test $(DATA)/007.merge.007b.test > $(TMP)/007.merge.007.observed
	@diff $(TMP)/007.merge.007.observed $(DATA)/007.merge.007.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
#	Test 008
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 008]"
	@$(BIN) -m $(DATA)/004.complement.004a.test $(DATA)/004.complement.004b.test $(DATA)/004.complement.004c.test > $(TMP)/008.merge.008.observed
	@diff $(TMP)/008.merge.008.observed $(DATA)/008.merge.008.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
#	Test 009
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 009]"
	@$(BIN) -m $(DATA)/004.difference.004.expected $(DATA)/005.difference.005.expected > $(TMP)/009.merge.009.observed
	@diff $(TMP)/009.merge.009.observed $(DATA)/009.merge.009.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"

complement:
#	Test 001
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 001]"
	@$(BIN) -c $(DATA)/001.merge.001.test > $(TMP)/001.complement.001.observed
	@diff $(TMP)/001.complement.001.observed $(DATA)/001.complement.001.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
#	Test 002
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 002]"
	@$(BIN) -c $(DATA)/002.merge.002.expected > $(TMP)/002.complement.002.observed
	@diff $(TMP)/002.complement.002.observed $(DATA)/002.complement.002.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
#	Test 003
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 003]"
	@$(BIN) -c $(DATA)/005.merge.005.expected > $(TMP)/003.complement.003.observed
	@diff $(TMP)/003.complement.003.observed $(DATA)/003.complement.003.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
#	Test 004
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 004]"
	@$(BIN) -c $(DATA)/004.complement.004a.test $(DATA)/004.complement.004b.test $(DATA)/004.complement.004c.test > $(TMP)/004.complement.004.observed
	@diff $(TMP)/004.complement.004.observed $(DATA)/004.complement.004.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
#	Test 005
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 005]"
	@$(BIN) -c $(DATA)/005.complement.005.test > $(TMP)/005.complement.005.observed
	@diff $(TMP)/005.complement.005.observed $(DATA)/005.complement.005.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
#	Test 006
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 006]"
	@$(BIN) -c -L $(DATA)/001.merge.001.test > $(TMP)/006.complement.006.observed
	@diff $(TMP)/006.complement.006.observed $(DATA)/006.complement.006.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
#	Test 007
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 007]"
	@$(BIN) -c -L $(DATA)/002.merge.002.expected > $(TMP)/007.complement.007.observed
	@diff $(TMP)/007.complement.007.observed $(DATA)/007.complement.007.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
#	Test 008
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 008]"
	@$(BIN) -c -L $(DATA)/005.merge.005.expected > $(TMP)/008.complement.008.observed
	@diff $(TMP)/008.complement.008.observed $(DATA)/008.complement.008.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
#	Test 009
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 009]"
	@$(BIN) -c -L $(DATA)/004.complement.004a.test $(DATA)/004.complement.004b.test $(DATA)/004.complement.004c.test > $(TMP)/009.complement.009.observed
	@diff $(TMP)/009.complement.009.observed $(DATA)/009.complement.009.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"

intersection:
#	Test 001
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 001]"
	@$(BIN) -i $(DATA)/001.intersection.001a.test $(DATA)/001.intersection.001b.test > $(TMP)/001.intersection.001.observed
	@diff $(TMP)/001.intersection.001.observed $(DATA)/001.intersection.001.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
#	Test 002
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 002]"
	@$(BIN) -i $(DATA)/001.intersection.001a.test $(DATA)/001.intersection.001b.test $(DATA)/002.intersection.002.test > $(TMP)/002.intersection.002.observed
	@diff $(TMP)/002.intersection.002.observed $(DATA)/002.intersection.002.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
#	Test 003
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 003]"
	@$(BIN) -i $(DATA)/008.merge.008.expected $(DATA)/004.complement.004.expected > $(TMP)/003.intersection.003.observed
	@diff $(TMP)/003.intersection.003.observed $(DATA)/003.intersection.003.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
#	Test 004
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 004]"
	@$(BIN) -i $(DATA)/004.intersection.004a.test $(DATA)/004.intersection.004b.test $(DATA)/004.intersection.004c.test > $(TMP)/004.intersection.004.observed
	@diff $(TMP)/004.intersection.004.observed $(DATA)/004.intersection.004.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"

difference:
#	Test 001
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 001]"
	@$(BIN) -d $(DATA)/004.intersection.004a.test $(DATA)/004.intersection.004b.test $(DATA)/004.intersection.004c.test > $(TMP)/001.difference.001.observed
	@diff $(TMP)/001.difference.001.observed $(DATA)/001.difference.001.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
#	Test 002
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 002]"
	@$(BIN) -d $(DATA)/002.difference.002a.test $(DATA)/002.difference.002b.test > $(TMP)/002.difference.002.observed
	@diff $(TMP)/002.difference.002.observed $(DATA)/002.difference.002.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
#	Test 003
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 003]"
	@$(BIN) -d $(DATA)/002.difference.002b.test $(DATA)/002.difference.002a.test > $(TMP)/003.difference.003.observed
	@diff $(TMP)/003.difference.003.observed $(DATA)/003.difference.003.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
#	Test 004
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 004]"
	@$(BIN) -d $(DATA)/004.difference.004a.test $(DATA)/004.difference.004b.test > $(TMP)/004.difference.004.observed
	@diff $(TMP)/004.difference.004.observed $(DATA)/004.difference.004.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
#	Test 005
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 005]"
	@$(BIN) -d $(DATA)/004.difference.004b.test $(DATA)/004.difference.004a.test > $(TMP)/005.difference.005.observed
	@diff $(TMP)/005.difference.005.observed $(DATA)/005.difference.005.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
#	Test 006
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 006]"
	@$(BIN) -d $(DATA)/004.symdiff.004.expected $(DATA)/009.merge.009.expected > $(TMP)/006.difference.006.observed
	@diff $(TMP)/006.difference.006.observed $(DATA)/006.difference.006.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
#	Test 007
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 007]"
	@$(BIN) -d $(DATA)/009.merge.009.expected $(DATA)/004.symdiff.004.expected > $(TMP)/007.difference.007.observed
	@diff $(TMP)/007.difference.007.observed $(DATA)/007.difference.007.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"

symdiff:
#	Test 001
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 001]"
	@$(BIN) -s $(DATA)/004.intersection.004a.test $(DATA)/004.intersection.004b.test > $(TMP)/001.symdiff.001.observed
	@diff $(TMP)/001.symdiff.001.observed $(DATA)/001.symdiff.001.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
#	Test 002
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 002]"
	@$(BIN) -s $(DATA)/004.intersection.004a.test $(DATA)/004.intersection.004b.test $(DATA)/004.intersection.004c.test > $(TMP)/002.symdiff.002.observed
	@diff $(TMP)/002.symdiff.002.observed $(DATA)/002.symdiff.002.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
#	Test 003
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 003]"
	@$(BIN) -s $(DATA)/003.symdiff.003a.test $(DATA)/003.symdiff.003b.test $(DATA)/003.symdiff.003c.test $(DATA)/003.symdiff.003d.test > $(TMP)/003.symdiff.003.observed
	@diff $(TMP)/003.symdiff.003.observed $(DATA)/003.symdiff.003.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
#	Test 004
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 004]"
	@$(BIN) -s $(DATA)/004.difference.004a.test $(DATA)/004.difference.004b.test > $(TMP)/004.symdiff.004.observed
	@diff $(TMP)/004.symdiff.004.observed $(DATA)/004.symdiff.004.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
#	Test 005
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 005]"
	@$(BIN) -s $(DATA)/009.merge.009.expected $(DATA)/004.symdiff.004.expected > $(TMP)/005.symdiff.005.observed
	@diff $(TMP)/005.symdiff.005.observed $(DATA)/005.symdiff.005.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"

element-of:
#	Test 001
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 001]"
	@$(BIN) -e $(DATA)/007.merge.007b.test $(DATA)/007.merge.007b.test > $(TMP)/001.element-of.001.observed
	@diff $(TMP)/001.element-of.001.observed $(DATA)/001.element-of.001.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
#	Test 002
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 002]"
	@$(BIN) -e 0 $(DATA)/003.symdiff.003a.test $(DATA)/003.symdiff.003b.test > $(TMP)/002.element-of.002.observed
	@diff $(TMP)/002.element-of.002.observed $(DATA)/002.element-of.002.expected || (printf " ...failed!\n" && exit 1)
	@printf " ...passed!\n"
#	Test 003
	@printf "[$(APP)-$(BUILDTYPE) --$@] - [Test 003]"

=== applications/bed/bedextract/src/Makefile ===
MAIN                    = ../../../..
MAINAPPDIR              = ../..
HEAD                    = $(MAIN)/interfaces/general-headers
LIB1                    = $(MAIN)/interfaces/src/data/measurement
LIB2                    = $(MAIN)/interfaces/src/utility
LIB3                    = $(MAIN)/interfaces/src/data/starch
THISDIR                 = ${shell pwd}
PARTY3                  = ${THISDIR}/$(MAIN)/third-party
OBJDIR                  = objects_${BINARY_TYPE}
LIBJANSSON              = libjansson.a
LIBBZIP2                = libbz2.a
LIBZLIB                 = libz.a
LOCALJANSSONDIR         = ${PARTY3}/jansson
LOCALJANSSONLIBDIR      = ${LOCALJANSSONDIR}/lib
LOCALJANSSONINCDIR      = ${LOCALJANSSONDIR}/include
LOCALJANSSONLIB         = ${LOCALJANSSONLIBDIR}/${LIBJANSSON}
LOCALBZIP2DIR           = ${PARTY3}/bzip2
LOCALBZIP2LIBDIR        = ${LOCALBZIP2DIR}
LOCALBZIP2LIB           = ${LOCALBZIP2LIBDIR}/${LIBBZIP2}
LOCALBZIP2INCDIR        = ${LOCALBZIP2DIR}
LOCALZLIBDIR            = ${PARTY3}/zlib
LOCALZLIBLIB            = ${LOCALZLIBDIR}/${LIBZLIB}
LOCALZLIBINCDIR         = ${LOCALZLIBDIR}
INCLUDES                = -iquote$(HEAD) -I${LOCALJANSSONINCDIR} -I${LOCALBZIP2INCDIR} -I${LOCALZLIBINCDIR}
LIBLOCATION             = -L${LOCALJANSSONLIBDIR} -L${LOCALBZIP2LIBDIR} -L${LOCALZLIBDIR}
LIBRARIES               = ${LOCALJANSSONLIB} ${LOCALBZIP2LIB} ${LOCALZLIBLIB}
BLDFLAGS                = -Wall -pedantic -O3 -std=c++11
SFLAGS                  = -static ${MEGAFLAGS}

dependency_names        = NaN starchConstants starchFileHelpers starchHelpers starchMetadataHelpers unstarchHelpers starchSha1Digest starchBase64Coding
dependencies            = $(addprefix $(OBJDIR)/, $(addsuffix .o, $(dependency_names)))
FLAGS                   = $(SFLAGS) -s $(BLDFLAGS) $(dependencies) ${LIBLOCATION} ${INCLUDES}
DFLAGS                  = $(SFLAGS) -g -O0 -std=c++11 -Wall -fno-inline -pedantic $(dependencies) ${LIBLOCATION} ${INCLUDES}
GPROFFLAGS              = $(SFLAGS) -O -std=c++11 -Wall -pedantic -pg $(dependencies) ${LIBLOCATION} ${INCLUDES}

SOURCE1                 = ExtractRows.cpp
BINDIR                  = ../bin
PROG                    = bedextract-${BINARY_TYPE}

build: $(BINDIR)/$(PROG)
	rm -rf ${OBJDIR}

build_gprof: $(BINDIR)/gprof.$(PROG)

build_debug: $(BINDIR)/debug.$(PROG)
	rm -rf ${OBJDIR}

dependencies: $(dependencies)

$(BINDIR)/$(PROG) : $(dependencies)
	mkdir -p $(BINDIR) && $(CXX) -o $@ $(CXXFLAGS) $(FLAGS) ${LIBRARIES} $(SOURCE1)

$(BINDIR)/gprof.$(PROG) : $(dependencies)
	mkdir -p $(BINDIR) && $(CXX) -o $@ $(CXXFLAGS) $(GPROFFLAGS) ${LIBRARIES} $(SOURCE1)

$(BINDIR)/debug.$(PROG) : $(dependencies)
	mkdir -p $(BINDIR) && $(CXX) -o $@ $(CXXFLAGS) $(DFLAGS) ${LIBRARIES} $(SOURCE1)

$(OBJDIR)/%.o : $(LIB1)/%.cpp
	mkdir -p $(OBJDIR) && $(CXX) -c $(CXXFLAGS) $(BLDFLAGS) $^ -o $@ ${INCLUDES}

$(OBJDIR)/%.o : $(LIB3)/%.c
	mkdir -p $(OBJDIR) && $(CXX) -c $(CXXFLAGS) ${BLDFLAGS} $^ -o $@ ${INCLUDES}

clean:
	rm -rf $(OBJDIR)
	rm -rf $(BINDIR)

=== applications/bed/bedops/src/Makefile ===
MAIN                = ../../../..
HEAD                = $(MAIN)/interfaces/general-headers
LIB1                = $(MAIN)/interfaces/src/data/measurement
LIB2                = $(MAIN)/interfaces/src/utility
LIB3                = $(MAIN)/interfaces/src/data/starch
TESTDIR             = ../test
TMPTESTDIR          = $(TESTDIR)/regression.tests
THISDIR             = ${shell pwd}
PARTY3              = ${THISDIR}/$(MAIN)/third-party
LIBJANSSON          = libjansson.a
LIBBZIP2            = libbz2.a
LIBZLIB             = libz.a
LOCALJANSSONDIR     = ${PARTY3}/jansson
LOCALJANSSONLIBDIR  = ${LOCALJANSSONDIR}/lib
LOCALJANSSONINCDIR  = ${LOCALJANSSONDIR}/include
LOCALJANSSONLIB     = ${LOCALJANSSONLIBDIR}/${LIBJANSSON}
LOCALBZIP2DIR       = ${PARTY3}/bzip2
LOCALBZIP2LIBDIR    = ${LOCALBZIP2DIR}
LOCALBZIP2LIB       = ${LOCALBZIP2LIBDIR}/${LIBBZIP2}
LOCALBZIP2INCDIR    = ${LOCALBZIP2DIR}
LOCALZLIBDIR        = ${PARTY3}/zlib
LOCALZLIBLIB        = ${LOCALZLIBDIR}/${LIBZLIB}
LOCALZLIBINCDIR     = ${LOCALZLIBDIR}
OBJDIR              = objects_${BINARY_TYPE}
INCLUDES            = -iquote$(HEAD) -I${LOCALJANSSONINCDIR} -I${LOCALBZIP2INCDIR} -I${LOCALZLIBINCDIR}
LIBLOCATION         = -L${LOCALJANSSONLIBDIR} -L${LOCALBZIP2LIBDIR} -L${LOCALZLIBDIR}
LIBRARIES           = ${LOCALJANSSONLIB} ${LOCALBZIP2LIB} ${LOCALZLIBLIB}
BLDFLAGS            = -Wall -pedantic -O3 -std=c++11
SFLAGS              = -static

dependency_names    = NaN starchConstants starchFileHelpers starchHelpers starchMetadataHelpers unstarchHelpers starchSha1Digest starchBase64Coding
dependencies        = $(addprefix $(OBJDIR)/, $(addsuffix .o, $(dependency_names)))
FLAGS               = $(SFLAGS) ${MEGAFLAGS} -s $(BLDFLAGS) $(dependencies) ${LIBLOCATION} ${INCLUDES}
DFLAGS              = $(SFLAGS) ${MEGAFLAGS} -g -O0 -DDEBUG_VERBOSE=1 -std=c++11 -Wall -fno-inline -pedantic -DDEBUG=1 $(dependencies) ${LIBLOCATION} ${INCLUDES}
GPROFFLAGS          = $(SFLAGS) ${MEGAFLAGS} -O -std=c++11 -Wall -pedantic -pg $(dependencies) ${LIBLOCATION} ${INCLUDES}
SOURCE1             = Bedops.cpp
BINDIR              = ../bin
PROG                = bedops-${BINARY_TYPE}

build: $(BINDIR)/$(PROG)
	rm -rf $(OBJDIR)

build_gprof: $(BINDIR)/gprof.$(PROG)
	rm -rf $(OBJDIR)

build_debug: $(BINDIR)/debug.$(PROG)
	rm -rf $(OBJDIR)

dependencies: $(dependencies)

$(BINDIR)/$(PROG) : $(dependencies)
	mkdir -p $(BINDIR) && $(CXX) -o $@ $(CXXFLAGS) $(FLAGS) ${LIBRARIES} $(SOURCE1)

$(BINDIR)/gprof.$(PROG) : $(dependencies)
	mkdir -p $(BINDIR) && $(CXX) -o $@ $(CXXFLAGS) $(GPROFFLAGS) ${LIBRARIES} $(SOURCE1)

$(BINDIR)/debug.$(PROG) : $(dependencies)
	mkdir -p $(BINDIR) && $(CXX) -o $@ $(CXXFLAGS) $(DFLAGS) ${LIBRARIES} $(SOURCE1)

$(OBJDIR)/%.o : $(LIB1)/%.cpp
	mkdir -p $(OBJDIR) && $(CXX) -c $(CXXFLAGS) $(BLDFLAGS) $^ -o $@ ${INCLUDES}

$(OBJDIR)/%.o : $(LIB3)/%.c
	mkdir -p $(OBJDIR) && $(CXX) -c $(CXXFLAGS) ${BLDFLAGS} $^ -o $@ ${INCLUDES}

test:
	mkdir -p $(TMPTESTDIR)
	cp $(TESTDIR)/TestPlan.xml $(TESTDIR)/Regression.java $(TMPTESTDIR)/
	cd $(TMPTESTDIR)/ && javac Regression.java
	printf "\n\nTo run regression tests:\n  cd $(TMPTESTDIR) && java Regression TestPlan.xml\n"

clean:
	rm -rf $(OBJDIR)
	rm -rf $(BINDIR)

clean_test:
	rm -rf $(TMPTESTDIR)

=== applications/bed/closestfeats/src/Makefile ===
MAIN                = ../../../..
HEAD                = $(MAIN)/interfaces/general-headers
LIB1                = $(MAIN)/interfaces/src/data/measurement
LIB2                = $(MAIN)/interfaces/src/utility
LIB3                = $(MAIN)/interfaces/src/data/starch
THISDIR             = ${shell pwd}
PARTY3              = ${THISDIR}/$(MAIN)/third-party
LIBJANSSON          = libjansson.a
LIBBZIP2            = libbz2.a
LIBZLIB             = libz.a
LOCALJANSSONDIR     = ${PARTY3}/jansson
LOCALJANSSONLIBDIR  = ${LOCALJANSSONDIR}/lib
LOCALJANSSONINCDIR  = ${LOCALJANSSONDIR}/include
LOCALJANSSONLIB     = ${LOCALJANSSONLIBDIR}/${LIBJANSSON}
LOCALBZIP2DIR       = ${PARTY3}/bzip2
LOCALBZIP2LIBDIR    = ${LOCALBZIP2DIR}
LOCALBZIP2LIB       = ${LOCALBZIP2LIBDIR}/${LIBBZIP2}
LOCALBZIP2INCDIR    = ${LOCALBZIP2DIR}
LOCALZLIBDIR        = ${PARTY3}/zlib
LOCALZLIBLIB        = ${LOCALZLIBDIR}/${LIBZLIB}
LOCALZLIBINCDIR     = ${LOCALZLIBDIR}
OBJDIR              = objects_${BINARY_TYPE}
INCLUDES            = -iquote$(HEAD) -I${LOCALJANSSONINCDIR} -I${LOCALBZIP2INCDIR} -I${LOCALZLIBINCDIR}
LIBLOCATION         = -L${LOCALJANSSONLIBDIR} -L${LOCALBZIP2LIBDIR} -L${LOCALZLIBDIR}
LIBRARIES           = ${LOCALJANSSONLIB} ${LOCALBZIP2LIB} ${LOCALZLIBLIB}
BLDFLAGS            = -Wall -pedantic -O3 -std=c++11
SFLAGS              = -static

dependency_names    = NaN starchConstants starchFileHelpers starchHelpers starchMetadataHelpers unstarchHelpers starchSha1Digest starchBase64Coding
dependencies        = $(addprefix $(OBJDIR)/, $(addsuffix .o, $(dependency_names)))
FLAGS               = $(SFLAGS) ${MEGAFLAGS} -s $(BLDFLAGS) $(dependencies) ${LIBLOCATION} ${INCLUDES}
DFLAGS              = $(SFLAGS) ${MEGAFLAGS} -g -O0 -std=c++11 -Wall -fno-inline -pedantic $(dependencies) ${LIBLOCATION} ${INCLUDES}
GPROFFLAGS          = $(SFLAGS) ${MEGAFLAGS} -O -std=c++11 -Wall -pedantic -pg $(dependencies) ${LIBLOCATION} ${INCLUDES}
SOURCE1             = ClosestFeature.cpp
BINDIR              = ../bin
PROG                = closest-features-${BINARY_TYPE}

build: $(BINDIR)/$(PROG)
	rm -rf $(OBJDIR)

build_gprof: $(BINDIR)/gprof.$(PROG)
	rm -rf $(OBJDIR)

build_debug: $(BINDIR)/debug.$(PROG)
	rm -rf $(OBJDIR)

dependencies: $(dependencies)

$(BINDIR)/$(PROG) : $(dependencies)
	mkdir -p $(BINDIR) && $(CXX) -o $@ $(CXXFLAGS) $(FLAGS) ${LIBRARIES} $(SOURCE1)

$(BINDIR)/gprof.$(PROG) : $(dependencies)
	mkdir -p $(BINDIR) && $(CXX) -o $@ $(CXXFLAGS) $(GPROFFLAGS) ${LIBRARIES} $(SOURCE1)

$(BINDIR)/debug.$(PROG) : $(dependencies)
	mkdir -p $(BINDIR) && $(CXX) -o $@ $(CXXFLAGS) $(DFLAGS) ${LIBRARIES} $(SOURCE1)

$(OBJDIR)/%.o : $(LIB1)/%.cpp
	mkdir -p $(OBJDIR) && $(CXX) -c $(CXXFLAGS) $(BLDFLAGS) $^ -o $@ ${INCLUDES}

$(OBJDIR)/%.o : $(LIB3)/%.c
	mkdir -p $(OBJDIR) && $(CXX) -c $(CXXFLAGS) ${BLDFLAGS} $^ -o $@ ${INCLUDES}

clean:
	rm -rf $(OBJDIR)
	rm -rf $(BINDIR)

=== applications/bed/conversion/src/Makefile ===
BLDFLAGS                  = -Wall -Wextra -pedantic -std=c99
COMMONFLAGS               = -D__STDC_CONSTANT_MACROS -D_FILE_OFFSET_BITS=64 -D_LARGEFILE64_SOURCE=1
CONVERSION_CFLAGS         = -O3
CONVERSION_CDFLAGS        = -DDEBUG=1 -g -O0 -fno-inline
CONVERSION_CPFLAGS        = -pg
LIBS                      = -lpthread
MAIN                      = ../../../..
INTERFACES                = $(MAIN)/interfaces
HEAD                      = ${INTERFACES}/general-headers
INCLUDES                 := -iquote"${CURDIR}" -iquote"${HEAD}"
DISTDIR                   = ../bin
OBJDIR                    = objects${POSTFIX}
WRAPPERDIR                = wrappers
PROG                      = convert2bed
SOURCE                    = convert2bed.c
SFLAGS                    = -static

all: build

.PHONY: build build_debug build_gprof clean

build: $(DISTDIR)/$(PROG)-${BINARY_TYPE}
	rm -rf $(OBJDIR)
build_debug: $(DISTDIR)/debug.$(PROG)-${BINARY_TYPE}
	rm -rf $(OBJDIR)
build_gprof: $(DISTDIR)/gprof.$(PROG)-${BINARY_TYPE}
	rm -rf $(OBJDIR)

$(DISTDIR)/$(PROG)-${BINARY_TYPE}: $(PROG).c
	mkdir -p $(DISTDIR) && $(CC) $(BLDFLAGS) ${MEGAFLAGS} $(COMMONFLAGS) $(CFLAGS) $(CONVERSION_CFLAGS) $(SFLAGS) $(INCLUDES) $^ -o $@ $(LIBS)

$(DISTDIR)/%-${BINARY_TYPE}: %.c
	mkdir -p $(DISTDIR) && $(CC) $(BLDFLAGS) ${MEGAFLAGS} $(COMMONFLAGS) $(CFLAGS) $(CONVERSION_CFLAGS) $(SFLAGS) $(INCLUDES) $^ -o $@ $(LIBS)

$(DISTDIR)/debug.$(PROG): $(PROG).c
	mkdir -p $(DISTDIR) && $(CC) $(BLDFLAGS) ${MEGAFLAGS} $(COMMONFLAGS) $(CFLAGS) $(CONVERSION_CDFLAGS) $(SFLAGS) $(INCLUDES) $^ -o $@ $(LIBS)

$(DISTDIR)/debug.%-${BINARY_TYPE}: %.c
	mkdir -p $(DISTDIR) && $(CC) $(BLDFLAGS) ${MEGAFLAGS} $(COMMONFLAGS) $(CFLAGS) $(CONVERSION_CDFLAGS) $(SFLAGS) $(INCLUDES) $^ -o $@ $(LIBS)

$(DISTDIR)/gprof.$(PROG): $(PROG).c gprof-helper.so
	mkdir -p $(DISTDIR) && $(CC) $(BLDFLAGS) ${MEGAFLAGS} $(COMMONFLAGS) $(CFLAGS) $(CONVERSION_CPFLAGS) $(SFLAGS) $(INCLUDES) $< -o $@ $(LIBS)
	@echo -e "\nNote: To profile convert2bed with gprof/pthreads, run:\n\t$$ LD_PRELOAD=/path/to/gprof-helper.so convert2bed"

$(DISTDIR)/gprof.%-${BINARY_TYPE}: %.c gprof-helper.so
	mkdir -p $(DISTDIR) && $(CC) $(BLDFLAGS) ${MEGAFLAGS} $(COMMONFLAGS) $(CFLAGS) $(CONVERSION_CPFLAGS) $(SFLAGS) $(INCLUDES) $< -o $@ $(LIBS)
	@echo -e "\nNote: To profile convert2bed with gprof/pthreads, run:\n\t$$ LD_PRELOAD=/path/to/gprof-helper.so convert2bed"

%.so: %.c
	$(CC) -shared -fPIC $^ -o $@ $(LIBS) -ldl

clean:
	rm -rf $(DISTDIR)
	rm -rf $(OBJDIR)
	rm -rf  *.so *~

=== applications/bed/starch/src/Makefile ===
HEAD                      = ../../../..
INTERFACES                = $(HEAD)/interfaces
MAIN                      = ${INTERFACES}/general-headers
MAINAPPDIR                = ../..
PARTY3                    = $(HEAD)/third-party
BINDIR                    = ../bin
THISDIR                   = ${shell pwd}
LIBSTARCH                 = libstarch${POSTFIX}.a
LIBSTARCHDEBUG            = libstarch_debug${POSTFIX}.a
LIBSTARCHGPROF            = libstarch_gprof${POSTFIX}.a
LIBJANSSON                = libjansson.a
LIBBZIP2                  = libbz2.a
LIBZLIB                   = libz.a
LOCALSTARCHLIBDIR         = ../lib
LOCALSTARCHLIB            = ${LOCALSTARCHLIBDIR}/${LIBSTARCH}
LOCALSTARCHLIBDEBUG       = ${LOCALSTARCHLIBDIR}/${LIBSTARCHDEBUG}
LOCALSTARCHLIBGPROF       = ${LOCALSTARCHLIBDIR}/${LIBSTARCHGPROF}
LOCALJANSSONDIR           = ${THISDIR}/${PARTY3}/jansson
LOCALJANSSONLIBDIR        = ${LOCALJANSSONDIR}/lib
LOCALJANSSONLIB           = ${LOCALJANSSONLIBDIR}/${LIBJANSSON}
LOCALJANSSONINCDIR        = ${LOCALJANSSONDIR}/include
LOCALBZIP2DIR             = ${THISDIR}/${PARTY3}/bzip2
LOCALBZIP2LIBDIR          = ${LOCALBZIP2DIR}
LOCALBZIP2LIB             = ${LOCALBZIP2LIBDIR}/${LIBBZIP2}
LOCALBZIP2INCDIR          = ${LOCALBZIP2DIR}
LOCALZLIBDIR              = ${THISDIR}/${PARTY3}/zlib
LOCALZLIBLIBDIR           = ${LOCALZLIBDIR}
LOCALZLIBLIB              = ${LOCALZLIBLIBDIR}/${LIBZLIB}
LOCALZLIBINCDIR           = ${LOCALZLIBDIR}
OBJDIR                    = ${INTERFACES}/src/data/starch
LOCALOBJDIR               = objects${POSTFIX}
INCLUDES                  = -iquote${MAIN} -iquote${HEAD} -iquote${PARTY3} -I${LOCALJANSSONINCDIR} -I${LOCALBZIP2INCDIR} -I${LOCALZLIBINCDIR}
LIBRARIES                 = ${LOCALJANSSONLIB} ${LOCALBZIP2LIB} ${LOCALZLIBLIB}
ARCH_VERSION              = v2.2
BIN_VERSION               = v2.4.40
TEST                      = ../test
TEST_LINUX_BINDIR         = ${TEST}/binaries/linux/${ARCH_VERSION}/bin
TEST_OSX_BINDIR           = ${TEST}/binaries/osx/${ARCH_VERSION}/bin
AR                        = ar
SFLAGS                    = -static
STARCH_CXXFLAGS           = -D__STDC_CONSTANT_MACROS -D_FILE_OFFSET_BITS=64 -D_LARGEFILE64_SOURCE=1 -DUSE_ZLIB -DUSE_BZLIB -O2 -Wformat -Wall -Wextra -Wswitch-enum -std=c++11 ${SFLAGS} -s
STARCH_CXXDFLAGS          = -D__STDC_CONSTANT_MACROS -D_FILE_OFFSET_BITS=64 -D_LARGEFILE64_SOURCE=1 -DUSE_ZLIB -DUSE_BZLIB -O0 -g -Wformat -Wall -Wextra -Wswitch-enum -std=c++11 -DDEBUG_VERBOSE=1 ${SFLAGS} -DDEBUG=1
STARCH_CXXGFLAGS          = -D__STDC_CONSTANT_MACROS -D_FILE_OFFSET_BITS=64 -D_LARGEFILE64_SOURCE=1 -DUSE_ZLIB -DUSE_BZLIB -O -Wformat -Wall -Wextra -Wswitch-enum -std=c++11 -DDEBUG_VERBOSE=1 ${SFLAGS} -DDEBUG=1 -pg

STARCH_NAMES              = starchConstants unstarchHelpers starchHelpers starchMetadataHelpers starchFileHelpers starchSha1Digest starchBase64Coding
STARCH_OBJECTS            = $(addprefix $(LOCALOBJDIR)/, $(addsuffix .o, $(STARCH_NAMES)))

.PHONY: starchcluster starch unstarch starchcat build build_debug build_gprof starch-diff starchstrip

build: starch unstarch starchcat starchcluster starch-diff starchstrip
	rm -rf ${LOCALOBJDIR}
build_debug: $(BINDIR)/debug.starch $(BINDIR)/debug.unstarch $(BINDIR)/debug.starchcat $(BINDIR)/debug.starchstrip starchcluster starch-diff
	rm -rf ${LOCALOBJDIR}
build_gprof: $(BINDIR)/gprof.starch $(BINDIR)/gprof.unstarch $(BINDIR)/gprof.starchcat $(BINDIR)/gprof.starchstrip starchcluster starch-diff
	rm -rf ${LOCALOBJDIR}

# Cancel implicit compilation rules
% : %.o
% : %.c

starch: $(BINDIR)/starch-$(BINARY_TYPE)
unstarch: $(BINDIR)/unstarch-$(BINARY_TYPE)
starchcat: $(BINDIR)/starchcat-$(BINARY_TYPE)
starchcluster: $(BINDIR)/starchcluster_gnuParallel-$(BINARY_TYPE) $(BINDIR)/starchcluster_sge-$(BINARY_TYPE) $(BINDIR)/starchcluster_slurm-$(BINARY_TYPE)
starch-diff: $(BINDIR)/starch-diff-$(BINARY_TYPE)
starchstrip: $(BINDIR)/starchstrip-$(BINARY_TYPE)

$(BINDIR)/%-$(BINARY_TYPE) : %.c $(LOCALSTARCHLIB) $(LIBRARIES)
	mkdir -p $(BINDIR)
	${CXX} ${CXXFLAGS} ${STARCH_CXXFLAGS} ${MEGAFLAGS} -c $*.c -o $(LOCALOBJDIR)/$*.o ${INCLUDES}
	${CXX} ${CXXFLAGS} ${STARCH_CXXFLAGS} ${MEGAFLAGS} $(LOCALOBJDIR)/$*.o -o $@ ${LOCALSTARCHLIB} ${LIBRARIES}

$(BINDIR)/debug.% : %.c $(LOCALSTARCHLIB) $(LIBRARIES)
	mkdir -p $(BINDIR)
	${CXX} ${CXXFLAGS} ${STARCH_CXXDFLAGS} ${MEGAFLAGS} -c $*.c -o $(LOCALOBJDIR)/$*.o ${INCLUDES}
	${CXX} ${CXXFLAGS} ${STARCH_CXXDFLAGS} ${MEGAFLAGS} $(LOCALOBJDIR)/$*.o -o $@-$(BINARY_TYPE) ${LOCALSTARCHLIB} ${LIBRARIES}

$(BINDIR)/gprof.% : %.c $(LOCALSTARCHLIB) $(LIBRARIES)
	mkdir -p $(BINDIR)
	${CXX} ${CXXFLAGS} ${STARCH_CXXGFLAGS} ${MEGAFLAGS} -c $*.c -o $(LOCALOBJDIR)/$*.o ${INCLUDES}
	${CXX} ${CXXFLAGS} ${STARCH_CXXGFLAGS} ${MEGAFLAGS} $(LOCALOBJDIR)/$*.o -o $@ ${LOCALSTARCHLIB} ${LIBRARIES}

$(BINDIR)/% : %.tcsh
	mkdir -p $(BINDIR)
	cp $< $@

$(BINDIR)/%-$(BINARY_TYPE) : %.tcsh
	mkdir -p $(BINDIR)
	cp $< $@

$(BINDIR)/% : %.py
	mkdir -p $(BINDIR)
	cp $< $@

$(BINDIR)/%-$(BINARY_TYPE) : %.py
	mkdir -p $(BINDIR)
	cp $< $@

starchLibrary: $(LOCALSTARCHLIB)

$(LOCALSTARCHLIB) : $(STARCH_OBJECTS)
	mkdir -p $(LOCALSTARCHLIBDIR)
	${AR} rcs $@ $^

$(LOCALOBJDIR)/%.o : $(OBJDIR)/%.c $(LIBRARIES)
	mkdir -p $(LOCALOBJDIR)
	${CXX} ${CXXFLAGS} ${STARCH_CXXFLAGS} ${MEGAFLAGS} -c $< -o $@ ${INCLUDES}

test: starch unstarch starchcat
	cp ${BINDIR}/starch-${BINARY_TYPE} ${TEST_LINUX_BINDIR}/starch-${BINARY_TYPE}
	cp ${BINDIR}/unstarch-${BINARY_TYPE} ${TEST_LINUX_BINDIR}/unstarch-${BINARY_TYPE}
	cp ${BINDIR}/starchcat-${BINARY_TYPE} ${TEST_LINUX_BINDIR}/starchcat-${BINARY_TYPE}
	make -C ${TEST} all

clean:
	rm -rf $(LOCALSTARCHLIBDIR)
	rm -f ${LOCALSTARCHLIBDEBUG}
	rm -f ${LOCALSTARCHLIBGPROF}
	rm -rf ${LOCALOBJDIR}
	rm -rf ${BINDIR}

=== docs/assets/reference/statistics/Makefile ===
figures:
	./reference_bedmap_make_overlap_figures.Rscript reference_bedmap_map.bed reference_bedmap_reference.bed reference_bedmap_mapref.pdf

padded_figures:
	bedops --range 100 --everything reference_bedmap_reference.bed > reference_bedmap_reference_padded.bed
	./reference_bedmap_make_overlap_figures.Rscript reference_bedmap_map.bed reference_bedmap_reference_padded.bed reference_bedmap_mapref_padded.pdf

=== debian/changelog ===
bedops (2.4.42+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.7.2 (routine-update)

 -- Steffen Moeller <moeller@debian.org>  Mon, 18 Aug 2025 00:04:42 +0200

=== debian/control ===
Source: bedops
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Olivier Sallou <osallou@debian.org>,
           Étienne Mollier <emollier@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               help2man,
               libbz2-dev,
               libjansson-dev,
               zlib1g-dev,
               tcsh
Build-Depends-Indep: sphinx-common,
                     dh-sequence-sphinxdoc,
                     libjs-mathjax,
                     python3-sphinx
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/med-team/bedops
Vcs-Git: https://salsa.debian.org/med-team/bedops.git
Homepage: https://github.com/bedops/bedops
Rules-Requires-Root: no

Package: bedops
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         python3,
         tcsh
Description: high-performance genomic feature operations
 BEDOPS is a suite of tools to address common questions raised in genomic
 studies, mostly with regard to overlap and proximity relationships between
 data sets.
 It aims to be scalable and flexible, facilitating the efficient and accurate
 analysis and management of large-scale genomic data.

Package: bedops-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         libjs-sphinxdoc,
         libjs-mathjax
Multi-Arch: foreign
Description: high-performance genomic feature operations (documentation)
 BEDOPS is a suite of tools to address common questions raised in genomic
 studies, mostly with regard to overlap and proximity relationships between
 data sets.
 It aims to be scalable and flexible, facilitating the efficient and accurate
 analysis and management of large-scale genomic data.
 .
 This package contains the BEDOPS documentation.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/pkg-info.mk

include /usr/share/dpkg/default.mk

include /usr/share/dpkg/architecture.mk

# less debug info to avoid running
# out of address space
ifneq (,$(filter $(DEB_HOST_ARCH), mips mipsel))
  export DEB_CFLAGS_MAINT_APPEND = -g1
  export DEB_CXXFLAGS_MAINT_APPEND = -g1
endif

docpkg := $(DEB_SOURCE)-doc

%:
	dh $@

override_dh_install-arch:
	dh_install -a
#	sed -i 's:/bin/tcsh:/usr/bin/tcsh:g' bin/*
	mv bin/starch bin/bedops-starch
	mkdir -p debian/$(DEB_SOURCE)/usr/bin/
	cp bin/* debian/$(DEB_SOURCE)/usr/bin/

override_dh_installdocs-indep:
	cd docs && make html
	mkdir -p debian/$(docpkg)/usr/share/doc/$(DEB_SOURCE)
	cp -r docs/_build/html debian/$(docpkg)/usr/share/doc/$(DEB_SOURCE)
	find debian/$(docpkg)/usr/share/doc/$(DEB_SOURCE)/html/content/usage-examples -type f | xargs sed -i 's;https://cdn[js]*\..*/MathJax.js;../../_static/mathjax.js;g'
	find debian/$(docpkg)/usr/share/doc/$(DEB_SOURCE)/html/content -type f | xargs sed -i 's;https://cdn[js]*\..*//MathJax.js;../_static/mathjax.js;g'
	find debian/$(docpkg)/usr/share/doc/$(DEB_SOURCE)/html -type f | xargs sed -i 's;https://cdn[js]*\..*/MathJax.js;_static/mathjax.js;g'
	ln -s /usr/share/javascript/mathjax/MathJax.js  debian/$(docpkg)/usr/share/doc/$(DEB_SOURCE)/html/_static/mathjax.js
	dh_installdocs -i

override_dh_installman-arch:
	cd bin && for f in * ; do help2man --no-discard-stderr --version-string="$(DEB_VERSION_UPSTREAM)" -o $$f.1 ./$$f; done
	dh_installman -a

override_dh_dwz:
	# Work around: dwz: Too few files for multifile optimization
	echo "Do not run dh_dwz"

override_dh_auto_clean:
	dh_auto_clean
	rm -rf docs/_build/
